/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package graphicChat.controller;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Logger;
import graphicChat.logger.OhmLogger;
import graphicChat.model.ChatModel;
import graphicChat.model.Figure;
import graphicChat.view.ChatView;
import java.util.List;
import java.util.function.Supplier;



/**
 *
 * @author hd, christ
 */
public class CommandSend implements ActionListener
{
  private static Logger lg = OhmLogger.getLogger();
  ChatView view;
  ChatModel model;
  private List<Figure> msg;
  
  public CommandSend(ChatView view, ChatModel model)
  {
    this.view = view;
    this.model = model;
  }
  
  
  public void registerEvents(){
    view.getBtnSend().addActionListener(this);
  }

  @Override
  public void actionPerformed(ActionEvent e)
  {
    Object src = e.getSource();
    
    if(src == view.getBtnSend()){
      /* view get figures*/
      msg = model.getSendFigures();
      model.sendMessage(msg);
      model.saveFigures(msg);
      view.getLblStatus().setText("Nachricht gesendet");
    }      
  }
}
